// global vars
// Interface elements
//-- window
var mainWindow;

//-- keys
var openSourceKey;
var openTranslationKey;
var saveKey;
var goToNextKey;
var aboutKey;
	
//-- menuitems
var openSourceMenu;
var openTranslationMenu;
var saveMenu;
var saveAsMenu;
var goToNextMenu;
	
var viewAllMenu;
var viewUntranslatedMenu;
	
var aboutMenu;

//-- buttons
var openSourceBtn;
var saveBtn;
var openTranslationBtn;
var viewAllBtn;
var viewUntranslatedBtn;
var goToNextBtn;

//-- descriptions
var textBox1Desc;
//-- textbox
var originalStringBox;
var translationBox;
	
//-- list
var stringCatalog;
// End of Interface elements

// array of id, varname, original translation, new translation
var fields = new Array();

// current item
// currentItem['var'] var name in item list
// currentItem['original'] original string
// currentItem['translation'] translation string
var currentItem = new Array();

// collection is a 'collection' of items that will be in the view (in the tree)
var collection = null;

// used for filter of open/save file dialogs
var filterExt = "*.php;*.php2;*.php3;*.php4;*.php5;*.phpx;*.phtml;*.inc;*.phps";
var filterName = "PHP files (" + filterExt + ")";

// path of the file to save to - saveFile will write into this
var saveFilePath = null; 

// state of application : there is a file opened
var translationInProgress = false;
/*********************************************************
						STARTUP
 *********************************************************/
/**
 * Function used to init the application at launch
 *
 * @author Piraux Sbastien <pir@cerdecam.be>
 * @desc 	- init all 'element' vars
 *          - start a new session of work
 */
function startup()
{
	// object references 
	//-- window
	mainWindow                       = document.getElementById('main-window');
	//-- keys
	openSourceKey					= document.getElementById('openSourceKey');
	openTranslationKey				= document.getElementById('openTransKey');
	saveKey							= document.getElementById('saveKey');
	goToNextKey						= document.getElementById('goToNextKey');
	aboutKey						= document.getElementById('aboutKey');
	
	//-- menuitems
	openSourceMenu					= document.getElementById('openSourceMenu');
	openTranslationMenu				= document.getElementById('openTransMenu');
	saveMenu						= document.getElementById('saveMenu');
	saveAsMenu						= document.getElementById('saveAsMenu');
	goToNextMenu					= document.getElementById('goToNextMenu');
	
	viewAllMenu					= document.getElementById('viewAllMenu');
	viewUntranslatedMenu		= document.getElementById('viewUntranslatedMenu');
	
	aboutMenu					= document.getElementById('aboutMenu');
	
	//-- buttons
	goToNextBtn					= document.getElementById('goToNextBtn');
	openSourceBtn				= document.getElementById('openSourceBtn');
	saveBtn 					= document.getElementById('saveBtn');	
	openTranslationBtn 			= document.getElementById('openTransBtn');

	viewAllBtn					= document.getElementById('viewAllBtn');
	viewUntranslatedBtn			= document.getElementById('viewUntranslatedBtn');

	//-- descriptions
    textBox1Desc                = document.getElementById('textBox1Desc');

	//-- textbox
	originalStringBox			= document.getElementById('originalString-box');
	translationBox				= document.getElementById('translatedString-box');
	
	//-- list
	stringCatalog				= document.getElementById('fieldsList');

	// start a new translation
	exNewTranslation();
}

/*********************************************************
					NEW TRANSLATION
 *********************************************************/
/**
 * Function used to start a new session
 *
 * @author Piraux Sbastien <pir@cerdecam.be>
 * @desc 	- disable some interface elements
 *          - empty the 2 textzones
 *          - (re)init array of all vars and translations
 *          - empty the list of vars in interface
 */
function exNewTranslation()
{
	// disable some interface elements
	openTranslationDisable(true);
	saveDisable(true);
	goToNextDisable(true);
	viewAllDisable(true);
	viewUntranslatedDisable(true);
    // adapt description
    textBox1Desc.value = "Reference string";
	// empty text zones
	originalStringBox.value = "";
	translationBox.value = "";

	// (re)init array of all vars and translations
	fields = new Array();

 	// empty the list of vars in interface
	emptyStringCatalog();
}

/**
 * Function used to ask a new session
 *
 * @author Piraux Sbastien <pir@cerdecam.be>
 * @desc display a popup message to ask confirmation if a session is currently
 *       running
 */
function rqNewTranslation()
{
	if ( translationInProgress )
	{

		if( confirm("Start a new translation.\nAll previous translations that have not been saved will be lost.\nConfirm ?") )
		{
			exNewTranslation();
			return true;
		}
		return false;
	}
	else
	{
		exNewTranslation();
		return true;
	}

}

/*********************************************************
				SOURCE FILE HANDLING
 *********************************************************/
/**
 * Function used to display the system dialog box used to pick a file
 *
 * @author Piraux Sbastien <pir@cerdecam.be>
 */
function openSourceFile()
{
	if( rqNewTranslation() )
	{	
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.appendFilter(filterName,filterExt);
		fp.init(window, "Open reference file", nsIFilePicker.modeOpen);
		
		var res = fp.show();
		if (res == nsIFilePicker.returnOK)
		{	
			if( parseFile(loadFile(fp.file.path), 'source') )
			{
				fillStringCatalog( 'all' );
				// set work in progress flag
				translationInProgress = true;
				// enable interface elements
				openTranslationDisable(false);
				saveDisable(false);
				goToNextDisable(false);
				viewAllDisable(false);
				viewUntranslatedDisable(false);
				// adapt description
                textBox1Desc.value = "Reference string - " + fp.file.leafName;
				// disable saveFilePath, 
				// to avoid the new translation to be saved on the previously saved file
				saveFilePath = null;
			}
		}
	}//else do nothing (cancel)
}

function loadFile( filePath ) 
{
	try 
	{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} 
	catch (e) 
	{
		alert("Permission to read file was denied.");
	}
	
	var file = Components.classes["@mozilla.org/file/local;1"]
				.createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath( filePath );

	if ( file.exists() == false ) 
	{
		alert("File does not exist");
	}
	var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
				.createInstance( Components.interfaces.nsIFileInputStream );
	is.init( file,0x01, 00004, null);
	
	var sis = Components.classes["@mozilla.org/scriptableinputstream;1"]
				.createInstance( Components.interfaces.nsIScriptableInputStream );
	sis.init( is );
	
	return sis.read(sis.available());
}
/*********************************************************
				PARSE PHP FILE
 *********************************************************/
function parseFile( fileContent, type )
{
	if( type == 'source' ) 
		var typeIsSource = true;
	else
		var typeIsSource = false;
		
	//-- file definition
	var commentsDelimiters = new Array();
	commentsDelimiters['//'] 	= '\n';
	commentsDelimiters['#'] 	= '\n';
	commentsDelimiters['/*']	= '*/';	

	var escapeChar = '\\';

    // used when in a a var but not between some [ ]
	var re = /[\w]/;  // \w == [a-zA-Z0-9_]
	// used when between [ and ] in an array var because there we may have a space or quotes  or dot (.) or hyphen (-)
	var reInArray = /[^\[\]]/;
	
	var contentLength = fileContent.length;

	var thisChar;
	
	var openString = ''; // quotemark use to open last string we met
	var inVar = false; // true if we are in a normal var $varname, or in an array var after a ]
	var inArrayVar = false; // true if we are in a array var $array['varname'], when between [ and ]
	var lastOpenPos = 0; // position of the last string/variable opening (first char right after the quotemark/$)
	
	var lastVar; // keep the name of the last var
	
	var isEscaped = false;
	
	for( var i = 0; i < contentLength; i++ )
	{
		thisChar = fileContent.substr(i, 1);
		
		if( inVar )
		{
			// if we detect a [ in the varname it means this is an array var
			if( thisChar = '[' )
			{
				inVar = false;
				inArrayVar = true;
			}
			else if( !re.test(thisChar) )
			{
				lastVar = fileContent.substr( lastOpenPos, i - lastOpenPos );
				inVar = false;
			}
		}
		else if( inArrayVar )
		{
			// when we are in a array type var, between the [ ] we can have some other chars like space, quotes, dot, hyphens
			// so the regex has to be different
			// if we meet a ] go back to normal use of
    		if( thisChar = ']' )
			{
				inVar = true;
				inArrayVar = false;
			}
			else if( !reInArray.test(thisChar) )
			{
				lastVar = fileContent.substr( lastOpenPos, i - lastOpenPos );
				inVar = false;
				inArrayVar = false;
			}
		}
		else if( isEscaped )
		{
			// thisChar is escaped
			isEscaped = false;
		}
		// if we match the escape char
		else if( thisChar == escapeChar )
		{
			// set the escape flag to escape the next char
			isEscaped = true;
		}
		// if we match the end of a string
		else if( thisChar == openString )
		{
			// end of the last string
			//alert(lastOpenPos + " " + (i - lastOpenPos) + " " + fileContent.substr( lastOpenPos, i - lastOpenPos ));
			
			if( lastVar != '' && isDefined(lastVar) )
			{
				if( typeIsSource )
				{
					fields[lastVar] = new Array();
					fields[lastVar][0] = fileContent.substr( lastOpenPos, i - lastOpenPos );
					fields[lastVar][1] = '';
				}
				else
				{
					if( isDefined(fields[lastVar]) )
					{
						fields[lastVar][1] = fileContent.substr( lastOpenPos, i - lastOpenPos );
					}
				}
			}
			openString = '';
		}
		// if we are not in a string
		else if( openString == '' ) 
		{
			// check for string delimiters
			if( thisChar == '"' || thisChar == '\'' )
			{
				// beginnning of a string
				openString = thisChar;	
				lastOpenPos = i + 1;
			}
			// check for a variable delimiter
			else if( thisChar == '$' )
			{
				inVar = true;
				lastOpenPos = i + 1;			
				lastVar = '';
			}
			// check for a comment
			else if( thisChar == '#' || thisChar == '/' )
			{
				// check if we match the start of a comment
				for ( openTag in commentsDelimiters )
				{
					// take the next chars according to the length of the opening tag
					testStr = fileContent.substr( i , openTag.length);
					
					if( testStr == openTag )
					{
						// find position of closing tag
						var restOfContent = fileContent.substr(i, contentLength - i);
						var closePos = restOfContent.indexOf(commentsDelimiters[openTag]);
	
						var openPos = i;
						// increment iterator to continue parsing from the end of the comment line
						i += closePos + commentsDelimiters[openTag].length - 1
						//alert(" comment : " + fileContent.substr(openPos,i - openPos) + "\n." + fileContent.substr(i,1) + "." );
					}
				}
			} // else do nothing, it's a 'we don't care'-char
		}
	}
	return true;
}

/*********************************************************
				TRANSLATION FILE HANDLING
 *********************************************************/
function openTranslationFile()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.appendFilter(filterName,filterExt);
	fp.init(window, "Open translation file", nsIFilePicker.modeOpen);	
	
	var res = fp.show();
	if (res == nsIFilePicker.returnOK)
	{
		if( parseFile(loadFile(fp.file.path), 'translation') )
		{
			// refresh translation of selected field 
			useCurrent();
			// disable saveFilePath, 
			// to avoid the new translation to be saved on the previously saved file
			saveFilePath = null;
		}
	}
}

/*********************************************************
							SAVE
 *********************************************************/

function saveFile()
{
	if( !saveFilePath )
	{
		if( !saveFileAs() )
		{
			return false;
		}
	}
	else
	{
		var file = Components.classes["@mozilla.org/file/local;1"]
						.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath( saveFilePath );
		if ( file.exists() == false ) 
		{
			file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
		}
		
		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
								.createInstance( Components.interfaces.nsIFileOutputStream );

		outputStream.init( file, 0x04 | 0x08 | 0x20, 420, 0 );

		var output = "<?php\n";
	
		for ( key in fields )
		{
			output += "$" + key + ' = "' + fields[key][1] + '";\n';
		}
		
		output += "?>";
		
		outputStream.write( output, output.length );
		outputStream.flush();
		outputStream.close();
	}
}

function saveFileAs()
{
	try
	{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserWrite");
	}
	catch(e)
	{
		alert("Permission to save file was denied.");
	}

	saveFilePath = null;
	// pick the file path
	var file = rqSaveFile();
	var path = file.path;  // complete path of the file : path/filename
	var filename = file.leafName; // name of the file

	if( path )
	{
		// test if the filename has an extension
  		var re = /.+\..+$/;
		if( !re.test( filename ) )
		{
			// if the filename doesn't have an extension add '.php'
			path = path + '.php';
		}
		saveFilePath = path;

  		saveFile();

		return true;
	}
	return false;
	
}

function rqSaveFile()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.appendFilter(filterName,filterExt);
	fp.init(window, "Save as ...", nsIFilePicker.modeSave);	
	
	var res = fp.show();
	if (res == nsIFilePicker.returnOK || res == nsIFilePicker.returnReplace )
	{
		return fp.file;
	}
	else
	{
		return false;
	}
}

/*********************************************************
						MODEL
 *********************************************************/
function treeModel()
{
  	this.rowCount = collection.size();

	this.getCellText = function(row,col)
	{
  		return collection.get(row);
 	}
	this.setTree = function(treebox){ this.treebox = treebox; }
	this.isContainer = function(row){ return false; }
	this.isSeparator = function(row){ return false; }
	this.isSorted = function(row){ return false; }
	this.getLevel = function(row){ return 0; }
	this.getImageSrc = function(row,col){ return null;}
	this.getRowProperties = function(row,props) {}
	this.getCellProperties = function(row,col,props){}
	this.getColumnProperties = function(colid,col,props) {}
}
/*********************************************************
				COLLECTIONS
 *********************************************************/
function completeCollection()
{
	var items = new Array();

	for ( key in fields )
	{
        // display all vars
		items.push(key);
	}

	this.get  = function(index) { return items[index]; }
	this.size = function() { return items.length; }
	this.getArray = function() { return items; }
}

function untranslatedCollection()
{
	var items = new Array();

	for ( key in fields )
	{
        // display only vars without translation
		if ( fields[key][1] == "" ) items.push(key);
	}

	this.get  = function(index) { return items[index]; }
	this.size = function() { return items.length; }
	this.getArray = function() { return items; }
}

function emptyCollection()
{
	var items = new Array();

	// empty collection so ... the items remains empty

	this.get  = function(index) { return items[index]; }
	this.size = function() { return items.length; }
	this.getArray = function() { return items; }
}
/*********************************************************
						OTHERS
 *********************************************************/
 
function useCurrent()
{
	// value of selected element in view
    currentItem['var'] = collection.get(stringCatalog.currentIndex);

	if( isDefined(fields[currentItem['var']][0]) )
	{
		originalStringBox.value = fields[currentItem['var']][0];
        currentItem['original'] = fields[currentItem['var']][0];
	}
	else
	{
		originalStringBox.value = "";
		currentItem['original'] = "";
	}

	if( isDefined(fields[currentItem['var']][1]) )
	{
		translationBox.value = fields[currentItem['var']][1];
		currentItem['translation'] = fields[currentItem['var']][1];;
	}
	else
	{
		translationBox.value = "";
		currentItem['translation'] = "";
	}
}

function saveCurrentItem()
{
	// handle the double quotes problem
	// replace possible \" by " and then replace all " by \"
	var translated = translationBox.value.replace(/\\\"/g, '"');
	translated = translated.replace(/\"/g, '\\"');
	
	// memorise new translation
	fields[currentItem['var']][1] = translated;
}

function goToNext()
{
    // get index of next element, or 0 if the current item is the last one
	if ( stringCatalog.currentIndex < collection.size()-1 )
		var nextItemIndex = stringCatalog.currentIndex + 1;
	else
		var nextItemIndex = 0;

	// select next item
	stringCatalog.view.selection.select( nextItemIndex );
	// ensure the selected row will be displayed
    stringCatalog.treeBoxObject.ensureRowIsVisible( nextItemIndex );
	// give focus back to the translation textbox
	translationBox.focus();
}

function fillStringCatalog( mode )
{
	// empty listbox to avoid duplicate entries
	emptyStringCatalog();

	// empty text zones
	originalStringBox.value = "";
	translationBox.value = "";

	if ( mode == 'empty' )
		collection = new untranslatedCollection();
	else
		collection = new completeCollection();

	// refresh the view
	stringCatalog.view = new treeModel();

	// select first item 
	stringCatalog.view.selection.select( 0 );
}


function emptyStringCatalog()
{
	// reset the collection, so the view will be empty
	collection = new emptyCollection();

 	stringCatalog.view = new treeModel();
}

function isDefined(varToCheck) 
{ 
	if(typeof(varToCheck) != "undefined") 
		return true; 
	else 
		return false; 
}

// Returns true or false based on whether the specified string is found
// in the array. This is based on the PHP function of the same name.
// Written by Beau Lebens <beau@dentedreality.com.au>
function in_array(stringToSearch, arrayToSearch) {
	for (s = 0; s < arrayToSearch.length; s++) {
		thisEntry = arrayToSearch[s].toString();
		if (thisEntry == stringToSearch) {
			return true;
		}
	}
	return false;
}

function closeWindow()
{
		window.close();
}

/*********************************************************
	ENABLE/DISABLE FUNCTION FOR MAIN INTERFACE ELEMENTS

	these functions are a convenient way to activate
	or deactivate interface elements
 *********************************************************/

function openSourceDisable( disable )
{
	openSourceKey.disabled = disable;
	openSourceMenu.setAttribute('disabled',disable);
	openSourceBtn.disabled = disable;
}

function openTranslationDisable( disable )
{
	openTranslationKey.disabled = disable;
	openTranslationMenu.setAttribute('disabled',disable);
	openTranslationBtn.disabled = disable;
}

function saveDisable( disable )
{
	saveKey.disabled = disable;
	saveMenu.setAttribute('disabled',disable);
	saveAsMenu.setAttribute('disabled',disable);
	saveBtn.disabled = disable;
}

function viewAllDisable( disable )
{	
	viewAllMenu.setAttribute('disabled',disable);
	viewAllBtn.disabled = disable;
}

function viewUntranslatedDisable( disable )
{
	viewUntranslatedMenu.setAttribute('disabled',disable);
	viewUntranslatedBtn.disabled = disable;
}

function goToNextDisable( disable )
{
	goToNextKey.disabled = disable;
	goToNextMenu.setAttribute('disabled',disable);
	goToNextBtn.disabled = disable;
}

/*********************************************************
						ABOUT
 *********************************************************/
// open the about & help window 
function showAbout()
{
	// get size and position of the main window
	var windowHeight = document.getElementById('main-window').boxObject.height;
	var windowWidth = document.getElementById('main-window').boxObject.width;
	var windowScreenX = document.getElementById('main-window').boxObject.screenX;
	var windowScreenY = document.getElementById('main-window').boxObject.screenY;

	// open about dialog, in the center of main-window, modal
	window.openDialog("chrome://phplangeditor/content/aboutdialog.xul", "test", 
			"screenY="+(windowHeight/2 - 250 + windowScreenY)+",screenX="+(windowWidth/2 - 250+windowScreenX)+
			",chrome,width=500,height=500,modal,centerscreen");
}	